org.eclnt.workplace

## Interface IWorkpage

- All Superinterfaces:
    java.io.Serializable
  All Known Subinterfaces:
    IWorkpageByPageBean
  All Known Implementing Classes:
    Workpage, WorkpageByPageBean

      public interface IWorkpage
      extends java.io.Serializable

  Abstraction of page/function that is started witin the workplace. Multiple workpage instances may be started, each one representing a function running in an isolated managed bean environment.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addLifecycleListener(IWorkpageLifecycleListener listener)`
    `void` | `addWorkpageProcessingEventListener(IWorkpageProcessingEventListener listener)`
    `void` | `assignIdToModelessPopup(ModelessPopup popup, java.lang.String id)`
    `boolean` | `close()` This method is called from the workpage container when the user requests the closing of the page.
    `boolean` | `closeAndContinue(java.lang.Runnable continueOperation)` This method is called from the workpage container - do not call this method directly!
    `void` | `closeForced()` This method forces the workpage to close - there is no chance to escape...
    `void` | `closeSemiModalPopup(IPageBean callingPageBean, IPageBean popupPageBean)` Close popup that was opened via `#openSemiModalPopup(IPageBean, String, int, int, org.eclnt.jsfserver.defaultscreens.ModelessPopup.IModelessPopupListener)`.
    `ModalPopup` | `createModalPopupInWorkpageContext()` Deprecated.
    `ModelessPopup` | `createModelessPopupInWorkpageContext()` Deprecated.
    `java.lang.String` | `getComment()` Comment - the comment is e.g. shown in tool tips.
    `IWorkpageDispatcher` | `getDispatcher()` Each workpage is associated with a dispatcher that manages the managed beans for this workpage.
    `boolean` | `getExcludeFromSavePerspective()` The workplace perspective management allows to store currently opened workplace arrangements as perspectives.
    `java.lang.String` | `getIconURL()` The icon of the workpage that is shown in the task overview.
    `java.lang.String` | `getId()` Each workpage specifies an id.
    `java.lang.String` | `getJspPage()` This is the start page of the workpage.
    `java.util.Set<IWorkpageLifecycleListener>` | `getLifecycleListeners()`
    `ModelessPopup` | `getModelesspopup(java.lang.String assignedId)`
    `ModelessPopup` | `getModelessPopupOfWorkpage()` A workpage may be opened as modeless popup.
    `java.lang.String` | `getParam(java.lang.String paramName)`
    `java.util.Map<java.lang.String,java.lang.String>` | `getParamMap()`
    `java.lang.String` | `getSelectorTitle()` The text that is shown inside the selector for the workpage.
    `java.lang.String` | `getStartSubWorkpageContainerId()`
    `java.lang.String` | `getTitle()` The title of the workpage.
    `java.lang.String` | `getUniqueTechnicalId()` Each workpage provides a technical id that is unique across all work pages.
    `IWorkpageContainer` | `getWorkpageContainer()` Returns the container this workpage is living in.
    `IWorkpageStartInfo` | `getWorkpageStartInfo()`
    `boolean` | `isBlocked()` Managed at runtime by workplace management: if a page opens up semi modal popup dialogs then the page need to be blocked.
    `boolean` | `isCloseSupported()` Indicates if the workpage can be closed via a close icon.
    `boolean` | `isDecorated()` Indicates if the workplace embeds the workpage into a frame with titlebar etc.
    `boolean` | `isPopupSupported()` Indicates if the workpage can be isolated from the workpage container into a modal popup.
    `ModelessPopup` | `openSemiModalPopup(IPageBean callingPageBean, IPageBean popupPageBean, java.lang.String title, int width, int height, ModelessPopup.IModelessPopupListener popupListener)` Open semi-modal popup.
    `void` | `processWorkpageProcessingEvent(WorkpageProcessingEvent event)` Process workpage processing event coming from other workpage.
    `boolean` | `reactOnBeforeHide()` This method is called before the workpage gets hidden e.g. due to user selection in the workpage selector.
    `void` | `reactOnDisplay()` This method is called whenever the workpage container is pushing this page to be displayed.
    `void` | `reactOnHide()` This method is called whenever a workpage that is currently shown within in the content area is replaced by another one.
    `void` | `reactOnReselectedInContentArea()` This method is called if the workpage is currently shown in its workpage container - and if the user re-selects the workpage.
    `void` | `reactOnShownInContentArea()` The page is (re)shown in the content area of the workplace.
    `void` | `reactOnShownInPopup()` The page is (re)shown in a modeless popup.
    `void` | `removeLifecycleListener(IWorkpageLifecycleListener listener)`
    `void` | `removeWorkpageProcessingEventListener(IWorkpageProcessingEventListener listener)`
    `void` | `setIconURL(java.lang.String value)` Update the icon during runtime.
    `void` | `setId(java.lang.String value)` The id can be changed during runtime.
    `void` | `setModelessPopupOfWorkpage(ModelessPopup popup)` Function that allows WorkpageContainer to set ModelessPopup instance.
    `void` | `setParam(java.lang.String paramName, java.lang.String paramValue)`
    `void` | `setSelectorTitle(java.lang.String selectorTitle)` Update selector title during runtime.
    `void` | `setTitle(java.lang.String title)` Update title during runtime.
    `void` | `setWorkpageStartInfo(IWorkpageStartInfo workpageStartInfo)`
    `void` | `throwWorkpageProcessingEvent(WorkpageProcessingEvent event)` Throws an event and triggers the delegation of the event to all other workpage instances.

- - ### Method Detail

    - #### getDispatcher

          IWorkpageDispatcher getDispatcher()

      Each workpage is associated with a dispatcher that manages the managed beans for this workpage. This is the dispatcher of the workpage.
      Please note: there is a dispatcher hierarchy - a top dispatcher ("#{d}") and there are sub-dispatchers, one for each workpage instance ("#{d.d_x}"). The dispatcher that is returned by this method is the workpage instance ("#{d.d_x}").

    - #### getJspPage

          java.lang.String getJspPage()

      This is the start page of the workpage.

    - #### getTitle

          java.lang.String getTitle()

      The title of the workpage.

    - #### getSelectorTitle

          java.lang.String getSelectorTitle()

      The text that is shown inside the selector for the workpage. If returned as null then the normal title via `getTitle()` is shown.

    - #### setTitle

          void setTitle(java.lang.String title)

      Update title during runtime.

    - #### setSelectorTitle

          void setSelectorTitle(java.lang.String selectorTitle)

      Update selector title during runtime.

    - #### getIconURL

          java.lang.String getIconURL()

      The icon of the workpage that is shown in the task overview.

    - #### setIconURL

          void setIconURL(java.lang.String value)

      Update the icon during runtime.

    - #### getId

          java.lang.String getId()

      Each workpage specifies an id. The id is used to check if a workpage is already included in a workpage container or not. The id needs to uniquely identify the workpage with its content.

    - #### setId

          void setId(java.lang.String value)

      The id can be changed during runtime.

    - #### isDecorated

          boolean isDecorated()

      Indicates if the workplace embeds the workpage into a frame with titlebar etc.

    - #### isPopupSupported

          boolean isPopupSupported()

      Indicates if the workpage can be isolated from the workpage container into a modal popup.

    - #### isCloseSupported

          boolean isCloseSupported()

      Indicates if the workpage can be closed via a close icon.

    - #### close

          boolean close()

      This method is called from the workpage container when the user requests the closing of the page. Do not call this method directly at the workpage - always go through the workpage container.
      Returns:
        True if the closing was successful, false if not (e.g. if unsaved data would get destroyed).

    - #### closeAndContinue

          boolean closeAndContinue(java.lang.Runnable continueOperation)

      This method is called from the workpage container - do not call this method directly! Always go through the workpage container!

    - #### closeForced

          void closeForced()

      This method forces the workpage to close - there is no chance to escape...

    - #### getWorkpageContainer

          IWorkpageContainer getWorkpageContainer()

      Returns the container this workpage is living in.

    - #### reactOnDisplay

          void reactOnDisplay()

      This method is called whenever the workpage container is pushing this page to be displayed.

    - #### reactOnHide

          void reactOnHide()

      This method is called whenever a workpage that is currently shown within in the content area is replaced by another one.

    - #### reactOnBeforeHide

          boolean reactOnBeforeHide()

      This method is called before the workpage gets hidden e.g. due to user selection in the workpage selector.

    - #### reactOnReselectedInContentArea

          void reactOnReselectedInContentArea()

      This method is called if the workpage is currently shown in its workpage container - and if the user re-selects the workpage.

    - #### setWorkpageStartInfo

          void setWorkpageStartInfo(IWorkpageStartInfo workpageStartInfo)

    - #### getWorkpageStartInfo

          IWorkpageStartInfo getWorkpageStartInfo()

    - #### setParam

          void setParam(java.lang.String paramName,
                        java.lang.String paramValue)

    - #### getParam

          java.lang.String getParam(java.lang.String paramName)

    - #### getParamMap

          java.util.Map<java.lang.String,java.lang.String> getParamMap()

    - #### addLifecycleListener

          void addLifecycleListener(IWorkpageLifecycleListener listener)

    - #### removeLifecycleListener

          void removeLifecycleListener(IWorkpageLifecycleListener listener)

    - #### getLifecycleListeners

          java.util.Set<IWorkpageLifecycleListener> getLifecycleListeners()

    - #### reactOnShownInContentArea

          void reactOnShownInContentArea()

      The page is (re)shown in the content area of the workplace.

    - #### reactOnShownInPopup

          void reactOnShownInPopup()

      The page is (re)shown in a modeless popup.

    - #### throwWorkpageProcessingEvent

          void throwWorkpageProcessingEvent(WorkpageProcessingEvent event)

      Throws an event and triggers the delegation of the event to all other workpage instances.

    - #### addWorkpageProcessingEventListener

          void addWorkpageProcessingEventListener(IWorkpageProcessingEventListener listener)

    - #### removeWorkpageProcessingEventListener

          void removeWorkpageProcessingEventListener(IWorkpageProcessingEventListener listener)

    - #### processWorkpageProcessingEvent

          void processWorkpageProcessingEvent(WorkpageProcessingEvent event)

      Process workpage processing event coming from other workpage.

    - #### createModalPopupInWorkpageContext

          @Deprecated
          ModalPopup createModalPopupInWorkpageContext()

      Deprecated.
      Creates a modal popup that runs in the context of the workpage.
      This method is deprecated because all popup dialog management should be done through page beans. It is still available for compatibility reasons.

    - #### createModelessPopupInWorkpageContext

          @Deprecated
          ModelessPopup createModelessPopupInWorkpageContext()

      Deprecated.
      Creates a modeless popup that runs in the context of the workpage.
      This method is deprecated because all popup dialog management should be done through page beans. It is still available for compatibility reasons.

    - #### assignIdToModelessPopup

          void assignIdToModelessPopup(ModelessPopup popup,
                                       java.lang.String id)

    - #### getModelesspopup

          ModelessPopup getModelesspopup(java.lang.String assignedId)

    - #### getModelessPopupOfWorkpage

          ModelessPopup getModelessPopupOfWorkpage()

      A workpage may be opened as modeless popup. This function returns the popup instance the workpage is running in. In case the workplage does not run in a modeless popup, null will be returned.
      Returns:

    - #### setModelessPopupOfWorkpage

          void setModelessPopupOfWorkpage(ModelessPopup popup)

      Function that allows WorkpageContainer to set ModelessPopup instance.

    - #### getStartSubWorkpageContainerId

          java.lang.String getStartSubWorkpageContainerId()

    - #### getUniqueTechnicalId

          java.lang.String getUniqueTechnicalId()

      Each workpage provides a technical id that is unique across all work pages. The technical id is assigned internally and does not provide any application semantics!

    - #### getExcludeFromSavePerspective

          boolean getExcludeFromSavePerspective()

      The workplace perspective management allows to store currently opened workplace arrangements as perspectives. The perspectives include the arrangement of workplace tiles - and the workpages that are currently started within the tile. - You can exclude the current workpage from being stored as part of a perspective by using this function.

    - #### getComment

          java.lang.String getComment()

      Comment - the comment is e.g. shown in tool tips.

    - #### isBlocked

          boolean isBlocked()

      Managed at runtime by workplace management: if a page opens up semi modal popup dialogs then the page need to be blocked.

    - #### openSemiModalPopup

          ModelessPopup openSemiModalPopup(IPageBean callingPageBean,
                                           IPageBean popupPageBean,
                                           java.lang.String title,
                                           int width,
                                           int height,
                                           ModelessPopup.IModelessPopupListener popupListener)

      Open semi-modal popup.
      Parameters:
        `pageBean` -
        `title` -
        `width` -
        `height` -
        `popupListener` -
      Returns:

    - #### closeSemiModalPopup

          void closeSemiModalPopup(IPageBean callingPageBean,
                                   IPageBean popupPageBean)

      Close popup that was opened via `#openSemiModalPopup(IPageBean, String, int, int, org.eclnt.jsfserver.defaultscreens.ModelessPopup.IModelessPopupListener)`.

Copyright © CaptainCasa Gmbh. All Rights Reserved.